'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _getIterator2 = require('babel-runtime/core-js/get-iterator');

var _getIterator3 = _interopRequireDefault(_getIterator2);

var _promise = require('babel-runtime/core-js/promise');

var _promise2 = _interopRequireDefault(_promise);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _fs = require('fs');

var _fs2 = _interopRequireDefault(_fs);

var _path = require('path');

var _path2 = _interopRequireDefault(_path);

var _webpack = require('webpack');

var _webpack2 = _interopRequireDefault(_webpack);

var _configureWebpack = require('./configure-webpack');

var _configureWebpack2 = _interopRequireDefault(_configureWebpack);

var _existsFileAsync = require('./exists-file-async');

var _existsFileAsync2 = _interopRequireDefault(_existsFileAsync);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

exports.default = function () {
  var _ref = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee(options) {
    var WORKINGDIR, OUTPUTFILE, files, entry, _iteratorNormalCompletion, _didIteratorError, _iteratorError, _iterator, _step, f;

    return _regenerator2.default.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            WORKINGDIR = options.root;
            OUTPUTFILE = options.output || '[name].bundle.js';

            if (options.entry.length) {
              _context.next = 4;
              break;
            }

            throw new Error('No entry file specified!');

          case 4:
            _context.next = 6;
            return _promise2.default.all(options.entry.map(function (f) {
              return (0, _existsFileAsync2.default)(_fs2.default, _path2.default.join(WORKINGDIR, f));
            }));

          case 6:
            files = _context.sent;
            entry = {};
            _iteratorNormalCompletion = true;
            _didIteratorError = false;
            _iteratorError = undefined;
            _context.prev = 11;


            for (_iterator = (0, _getIterator3.default)(files); !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
              f = _step.value;

              entry[_path2.default.basename(f, '.js')] = f;
            }

            _context.next = 19;
            break;

          case 15:
            _context.prev = 15;
            _context.t0 = _context['catch'](11);
            _didIteratorError = true;
            _iteratorError = _context.t0;

          case 19:
            _context.prev = 19;
            _context.prev = 20;

            if (!_iteratorNormalCompletion && _iterator.return) {
              _iterator.return();
            }

          case 22:
            _context.prev = 22;

            if (!_didIteratorError) {
              _context.next = 25;
              break;
            }

            throw _iteratorError;

          case 25:
            return _context.finish(22);

          case 26:
            return _context.finish(19);

          case 27:
            return _context.abrupt('return', (0, _webpack2.default)((0, _configureWebpack2.default)({
              context: WORKINGDIR,
              devtool: options.devtool ? options.devtool : false,
              production: options.production,
              output: {
                path: WORKINGDIR,
                filename: OUTPUTFILE,
                sourceMapFilename: OUTPUTFILE + '.map'
              },
              plugins: options.common ? [new _webpack2.default.optimize.CommonsChunkPlugin({
                name: options.common,
                filename: options.common
              })] : null,
              entry: entry
            })));

          case 28:
          case 'end':
            return _context.stop();
        }
      }
    }, _callee, this, [[11, 15, 19, 27], [20,, 22, 26]]);
  }));

  return function (_x) {
    return _ref.apply(this, arguments);
  };
}();
//# sourceMappingURL=configure-bundler.js.map