'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _promise = require('babel-runtime/core-js/promise');

var _promise2 = _interopRequireDefault(_promise);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _child_process = require('child_process');

var _path = require('path');

var _path2 = _interopRequireDefault(_path);

var _fs = require('fs');

var _fs2 = _interopRequireDefault(_fs);

var _ncp = require('ncp');

var _ncp2 = _interopRequireDefault(_ncp);

var _commandExists = require('command-exists');

var _commandExists2 = _interopRequireDefault(_commandExists);

var _chalk = require('chalk');

var _chalk2 = _interopRequireDefault(_chalk);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

exports.default = function () {
  var _ref = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee(options) {
    var dir;
    return _regenerator2.default.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            if (!(typeof options.name !== 'string')) {
              _context.next = 2;
              break;
            }

            throw new Error('Please specify a name for the project!');

          case 2:
            dir = _path2.default.join(options.root, options.name);

            if (!_fs2.default.existsSync(dir)) {
              _context.next = 5;
              break;
            }

            throw new Error('A folder named \'' + options.name + '\' already exits!');

          case 5:

            console.log('📃  Copying template files');

            _context.next = 8;
            return new _promise2.default(function (resolve, reject) {
              _ncp2.default.ncp(_path2.default.join(__dirname, '../template/'), dir, function (err) {
                if (err) {
                  reject(err);
                  return;
                }

                (0, _commandExists2.default)('yarn', function (error, status) {
                  if (error) {
                    reject(error);
                    return;
                  }

                  try {
                    console.log('\uD83C\uDF6D  Installing ' + _chalk2.default.bold('react') + ' and ' + _chalk2.default.bold('react-dom'));

                    if (status) {
                      (0, _child_process.execSync)('yarn add react react-dom', { cwd: dir });
                    } else {
                      (0, _child_process.execSync)('npm install -S react react-dom', { cwd: dir });
                    }

                    console.log('\uD83D\uDC8E  Adding ' + _chalk2.default.bold('quik') + ' as a devDependency');

                    if (status) {
                      (0, _child_process.execSync)('yarn add --dev quik', { cwd: dir });
                    } else {
                      (0, _child_process.execSync)('npm install -D quik', { cwd: dir });
                    }

                    resolve();
                  } catch (e) {
                    reject(e);
                  }
                });
              });
            });

          case 8:
          case 'end':
            return _context.stop();
        }
      }
    }, _callee, this);
  }));

  return function (_x) {
    return _ref.apply(this, arguments);
  };
}();
//# sourceMappingURL=init.js.map