'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

exports.default = function (options) {
  var middlewares = [];

  middlewares.push((0, _quikMiddlewareJs2.default)({
    devtool: 'inline-source-map',
    root: options.root
  }));

  var script = void 0,
      watch = void 0;

  if (options.run) {
    script = options.run;
    watch = [script];
  } else if (options.watch) {
    watch = options.watch;
  } else {
    var index = 'index.js';

    try {
      _fs2.default.accessSync(index, _fs2.default.R_OK);
      watch = [index];
    } catch (e) {
      // Do nothing
    }

    try {
      _fs2.default.accessSync('index.html', _fs2.default.R_OK);
    } catch (e) {
      script = index;
    }
  }

  if (script) {
    middlewares.push((0, _quikMiddlewareRun2.default)({
      root: options.root,
      script: script
    }));
  }

  if (watch && watch.length) {
    middlewares.push((0, _quikMiddlewareHmr2.default)({
      devtool: 'inline-source-map',
      root: options.root,
      entry: watch
    }));
  }

  return (0, _koaCompose2.default)(middlewares);
};

var _fs = require('fs');

var _fs2 = _interopRequireDefault(_fs);

var _koaCompose = require('koa-compose');

var _koaCompose2 = _interopRequireDefault(_koaCompose);

var _quikMiddlewareHmr = require('./quik-middleware-hmr');

var _quikMiddlewareHmr2 = _interopRequireDefault(_quikMiddlewareHmr);

var _quikMiddlewareJs = require('./quik-middleware-js');

var _quikMiddlewareJs2 = _interopRequireDefault(_quikMiddlewareJs);

var _quikMiddlewareRun = require('./quik-middleware-run');

var _quikMiddlewareRun2 = _interopRequireDefault(_quikMiddlewareRun);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
//# sourceMappingURL=quik-middleware.js.map